day34|leetcode 62不同路径,63.不同路径II

4.不同路径

一个机器人位于一个 m x n 网格的左上角 (起始点在下图中标记为 "Start" )。

机器人每次只能向下或者向右移动一步。机器人试图达到网格的右下角(在下图中标记为 "Finish" )。

问总共有多少条不同的路径?

思路:

(1)暴力方法:深度搜索:

cpp 复制代码
class Solution {
private:
    int dfs(int i,int j,int m,int n)
    {
        if(i>m||j>n)return 0;//越界
        if(i==m && j==n)return 1;
        return dfs(i+1,j,m,n)+dfs(i,j+1,m,n);
    }
public:
    int uniquePaths(int m, int n) {
        return dfs(1,1,m,n);
    }
};

时间复杂度:O(2^(m+n-1)-1)

超时

(2)动态规划:

动规五部曲:

1.dpi j含义:从(0,0)出发到(i,j)有dpi j条路径

2.递推公式:dpi j只可能从dpi-1 j或者dpi j-1两个方向推过来,所以dpi j=dpi-1 j =dpi j-1

3.dp数组初始化:dp0 j=1,dpi 0=1;从(0,0)到(0,i)只可能有一条路,到(0,j)也同理

4.遍历顺序:从上到下,从左到右

5.打印dp数组

cpp 复制代码
class Solution {
public:
    int uniquePaths(int m, int n) {
        vector<vector<int>>dp(m,vector<int>(n,0));
        for(int i=0;i<m;i++)dp[i][0]=1;//初始化
        for(int j=0;j<n;j++)dp[0][j]=1;
        for(int i=1;i<m;i++)//从上往下,从1开始,防止i-1越界
        {
            for(int j=1;j<n;j++)//从左往右
            {
              dp[i][j]=dp[i-1][j]+dp[i][j-1];
            }
        }
        return dp[m-1][n-1];
    }
};

时间复杂度:O(m×n)

5.不同路径II

给定一个 m x n 的整数数组 grid。一个机器人初始位于 左上角 (即 grid[0][0])。机器人尝试移动到 右下角 (即 grid[m - 1][n - 1])。机器人每次只能向下或者向右移动一步。

网格中的障碍物和空位置分别用 1 和 0 来表示。机器人的移动路径中不能包含 任何 有障碍物的方格。

返回机器人能够到达右下角的不同路径数量。

测试用例保证答案小于等于 2 * 109。

进阶点在于:如何排除障碍物所在的路径

解决思路:和上一题基本一样。只是在碰到障碍物时保持直接跳过

cpp 复制代码
class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        int m= obstacleGrid.size();
        int n= obstacleGrid[0].size();
        if(obstacleGrid[0][0]==1 || obstacleGrid[m-1][n-1]==1)return 0;//在起点或者终点出现障碍直接返回0
​
        vector<vector<int>>dp(m,vector<int>(n,0));
        for(int i=0;i<m && obstacleGrid[i][0]==0;i++)dp[i][0]=1;//初始化
        for(int j=0;j<n && obstacleGrid[0][j]==0;j++)dp[0][j]=1;
        for(int i=1;i<m;i++)
        {
            for(int j=1;j<n;j++)
            {
                if(obstacleGrid[i][j]==1)continue;//有障碍物不进行这一轮的运算,跳到下一步
                dp[i][j]=dp[i-1][j]+dp[i][j-1];
            }
        }
        return dp[m-1][n-1];
        }
};
复制代码
时间复杂度:O(m×n)

需要注意的一些细节:

(1)二维数组的长m和宽n需要通过obstacleGrid数组确定

(2)在起点或者终点出现障碍直接返回0

(3)初始化时注意障碍点不参与初始化

相关推荐
会编程的小孩7 小时前
C++ qt的安装
c++
企业数字化笔记9 小时前
视频人体姿态怎么做三维可视化?2D关键点、深度局限与技术选型
人工智能·算法·音视频
?abc!10 小时前
(数组)581. 最短无序连续子数组
数据结构·算法·leetcode
小成2023032026512 小时前
C++~07补充
开发语言·c++
小郎君65812 小时前
MPTT树复选框的半选状态:一棵百万节点树从递归到计数器,再到区间覆盖
算法
酌沧12 小时前
MemT让记忆成为模型内生能力
jvm·人工智能·算法
hold?fish:palm12 小时前
40 二叉树的直径
c++·leetcode
Shimeri13 小时前
越卷越像:我用遗传算法做了个"内卷"实验
算法·three.js·数据可视化·遗传算法·进化算法
解决小子13 小时前
【虚幻引擎】【C++】【GAS框架】构建角色基类、属性集、数值钳制
c++·笔记·游戏引擎·虚幻·gas·能力系统
Evand J13 小时前
【PMSM例程1】永磁同步电机(PMSM)转速与转子电角度观测算法|基于扩展卡尔曼滤波(EKF)的传感器状态估计与误差。附下载链接
算法·电机·1024程序员节·卡尔曼滤波